clear all 
if ispc
    fprintf('NCO commands only work on Linux')
else
    bp =  '/storage/nilu/Inby/Aktive-prosjekter/o120107_EmSite/';
    addpath /storage/nilu/Inby/Users/heg/MatLab/Tools
end

%--------------------------------------------------------------------------
% BASIC pathnames
opname   = sprintf('%s%s',bp,'EmSite_Model/Output/');
ipath    = sprintf('%s%s',bp,'EmSite_Model/Input/');
tpath    = sprintf('%s%s',bp,'EmSite_Model/Temp/');


daily_runoff  = 0.9; % HEG parameterization factors

Vname   = 'DEM';

for Emission_year = 2010:2019;
    % Emission_year = 2010
    [Met] = EmSite_Calc_Met_Thornthwaite(Emission_year,ipath);
    PET  = Met.PET;  clear Met
    [Met] = EmSite_Calc_Met_Get_Precipitation(Emission_year,ipath);
    PRECd = Met.DayPrecipitation;  clear Met
    EP(:,:,1) = PRECd(:,:,1)*0;
    for i=2:size(PET,3)
        EP(:,:,i) = max(0,EP(:,:,i-1).*daily_runoff.^PET(:,:,i-1)-PET(:,:,i-1)+PRECd(:,:,i-1));
    end
    EP(:,:,1) = EP(:,:,2);
    DEM       = 1./(EP+1);
    clear EP PRECd
    
    ncorig   = sprintf('%sMET/rr_%04i.nc',ipath,Emission_year);
    ncfile   = sprintf('%sMET/DEM_%04i.nc',ipath,Emission_year);
    system(sprintf('ncks -x -v rr %s %s',ncorig,ncfile))
    % system(sprintf('ncks -x -v rra %s %s',ncfile,ncfile))
    
    ifo     = ncinfo(ncfile);
    for i=1:size(ifo.Variables,2)
        a(i) = {ifo.Variables(i).Name};
    end
    nccreate(ncfile, Vname, 'Dimensions', {'X', ifo.Dimensions(1).Length,'Y', ifo.Dimensions(2).Length, 'time',ifo.Dimensions(4).Length}, 'DataType', 'single');
    ncwrite(ncfile , Vname, DEM);
end

%     LVname    = Vname;
%     
%     if sum(ismember(a,Vname))==0
%     nccreate(ofname  , Vname, 'Dimensions', {'X', ifo.Dimensions(1).Length,'Y', ifo.Dimensions(2).Length}, 'DataType', 'single');
%     end


