function [Met] = EmSite_Calc_FindMet(Stmp,Hdays,ipath)
ydm   = datevec(Hdays);
yyyy  = unique(ydm(:,1));

Temp   = [];
Precip = [];
Dates  = [];
for year = 1:length(yyyy)    
    fprintf('%i ',yyyy(year))
    ncfile  = sprintf('%sMET/TG_%04i.nc',ipath,yyyy(year));
    ncfile2 = sprintf('%sMET/rr_%04i.nc',ipath,yyyy(year));
% %    ifo =  ncinfo(ncfile);    
    t = ncread(ncfile,'time');
    tpr  = squeeze(ncread(ncfile,'tg',[Stmp.MetX,Stmp.MetY,1],[1,1,length(t)]));
    fprintf('. ')
    prec = squeeze(ncread(ncfile2,'rr',[Stmp.MetX,Stmp.MetY,1],[1,1,length(t)]));
    fprintf('.\n')
    dato   = (datenum([yyyy(year), 1 1, 0 0 0 ]):1:datenum([yyyy(year), 1 1, 0 0 0 ])+length(t))';    
    Temp   = [Temp; tpr];
    Precip = [Precip; prec];
    Dates  = [Dates; dato];
end
idx1 = Dates>= min(Hdays);
idx2 = Dates<= max(Hdays);
idx = idx1 & idx2;

Met.Dates         = Dates(idx)';
Met.Precipitation = Precip(idx)';
Met.Temperature   = Temp(idx)';
end