function [Met] = EmSite_Calc_FindMetField(Stmp,ipath)
% Find the closest centerpoint of the met grid to a point.
% Use the 2011 field: year doesnt matter as it is a static grid.

year = 2011;
ncfile  = sprintf('%sMET/TG_%04i.nc',ipath,year);
x = ncread(ncfile,'X');
y = ncread(ncfile,'Y');
if ~isnan(Stmp.X) & ~isnan(Stmp.Y)
    xdst = sqrt((nanmean(Stmp.X)-x).^2);
    ydst = sqrt((nanmean(Stmp.Y)-y).^2);
    px = find(xdst== min(xdst));
    py = find(ydst== min(ydst));
    Met.FieldXY = [px(1),py(1)];
    Met.DistXY = [min(xdst),min(ydst)];
else
    Met.FieldXY = [NaN,NaN];
    Met.DistXY = [NaN,NaN];
end
end