function [Met] = EmSite_Calc_MetHDD(Emission_year,ipath,Htres)
fprintf('Finding gridded HDD in %i \n',Emission_year)
ncfile   = sprintf('%sMET/TG_%04i.nc',ipath,Emission_year);
tpr     = ncread(ncfile,'tg');
HDD     = max(0,Htres-tpr);
aHDD    = sum(HDD,3);
yearday = datenum([Emission_year, 1 1 0 0 0]):1:datenum([Emission_year+1, 1 1 0 0 0]);
dt = datevec(yearday);
for month = 1:12
    idx = dt(:,2)==month;
    mHDD(:,:,month) = sum(HDD(:,:,idx),3);
end
Met.AnnualHDD   = aHDD;
Met.MonthHDD    = mHDD;
Met.HDD         = HDD;
end

% 
% 
% ncfile2  = sprintf('%sMET/rr_%04i.nc',ipath,Emission_year);
% prec    = ncread(ncfile2,'rr');
% 
% 
% 
% t       = ncread(ncfile,'time');
% tpr     = squeeze(ncread(ncfile,'tg',[Stmp.MetX,Stmp.MetY,1],[1,1,length(t)]));
% fprintf('.')
% prec    = squeeze(ncread(ncfile2,'rr',[Stmp.MetX,Stmp.MetY,1],[1,1,length(t)]));
% fprintf('.\n')
% dato    = (datenum([Emission_year, 1 1, 0 0 0 ]):1:datenum([Emission_year, 1 1, 0 0 0 ])+length(t))';

% Met.Dates         = dato;
% Met.Precipitation = prec;
