function [Met] = EmSite_Calc_Met_Thornthwaite_index(Emission_year,ipath)


yearday = datenum([Emission_year, 1 1 0 0 0]):1:datenum([Emission_year+1, 1 1 0 0 0]);
dt = datevec(yearday);

fprintf('Finding monthly gridded Thorntwaite Index:\n')
fprintf('Following Thorntwaite (1948) for year   %i \n',Emission_year)

ncfile   = sprintf('%sMET/TG_%04i.nc',ipath,Emission_year);
tpr      = ncread(ncfile,'tg');
fprintf('Monthly mean Temperature (Celsius) \n')
for month = 1:12
    idx = dt(:,2) == month;
    mT(:,:,month) =  mean(tpr(:,:,idx),3);
end
%clear tpr
ncfile2    = sprintf('%sMET/rr_%04i.nc',ipath,Emission_year);
pre        = ncread(ncfile2,'rr');
fprintf('Monthly Precipitation (mm) \n')
for month = 1:12
    idx = dt(:,2) == month;
    mP(:,:,month) =  sum(pre(:,:,idx),3);
end
%clear pre
% remove monthly temperatures below 0
minTemp =-4;
mT(mT<minTemp)=minTemp;
tPEm           = (mP./(1.8*mT+22));% 
tPEm(tPEm<0) = 0;
tPEm = tPEm.^(10/9);
PEindex = 3.16*sum(tPEm,3);

makeplot = 0;
if makeplot
    figure(1);clf
    for i=1:12
        subplot(4,3,i)
        imagesc(tPEm(:,:,i)')
        colorbar
    end
    
    figure(2);clf
    imagesc(nansum(pre,3)')
    colorbar
end

Met.PEindex = PEindex;
Met.PEindexM =tPEm;
end


% PEindex(PEindex == 0) = NaN;
% PEindex(PEindex>120) = 120
% imagesc((PEindex)')
% imagesc(mP(:,:,7)')
% imagesc(mT(:,:,1)')
% imagesc(tPEm(:,:,7)')
% imagesc(tPEm(:,:,1)')
