function [TB,Sout] = EmSite_Geoprocess_Add_NGI_Soil(Dirt,Sout,Xmid,Ymid,Diam)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

fprintf('Adding Soil parameters to all buildings\n')
% find the soil layer that each building is in:
numBuild = length(Sout);
k=1; clear Missed
for b = 1:numBuild
    clear p
    xb = Sout(b).X;
    yb = Sout(b).Y;
    if yb~=0
        dst = sqrt( (xb-Xmid).^2 + (yb-Ymid).^2);
        ids = find(dst<Diam);
        if isempty(ids)
            ids = find((dst-min(dst)==0));
        end
        %fprintf('%i\n',length(ids))
        for i=1:length(ids)
            in = inpolygon(xb,yb,Dirt(ids(i)).X,Dirt(ids(i)).Y);
            if in; p = ids(i);  end
        end
        
    end
    
    if exist('p')
        jordart(b)   = Dirt(p).jordart;
        infilt(b)    = Dirt(p).infilt;
        grunnvann(b) = Dirt(p).grunnvann;
    else
        if xb~=0 && yb~=0
            Missed(k)=Sout(b).Bygningsnr; k=k+1;
            fprintf('Checked the %i closest geo centroids xb=%f, yb=%f Bygningsnummer: %i \n',length(ids),xb,yb,Sout(b).Bygningsnr)
        end
        jordart(b)  = NaN;
        infilt(b)   = NaN;
        grunnvann(b) = NaN;
    end
    if rem(b,5000)==0; fprintf('Processed %i / %i Soil \n',b,length(Sout)), end
end
TB = struct2table(Sout);
TB.Jordart   = jordart';
TB.Infilt    = infilt';
TB.Grunnvann = grunnvann';
Sout = table2struct(TB);
fprintf('Jordart   added: %i / %i missing: %i\n',sum(~isnan(jordart))  ,length(Sout),length(Sout)-sum(~isnan(jordart)))
fprintf('Infilt    added: %i / %i missing: %i\n',sum(~isnan(infilt))   ,length(Sout),length(Sout)-sum(~isnan(infilt)))
fprintf('Grunnvann added: %i / %i missing: %i\n',sum(~isnan(grunnvann)),length(Sout),length(Sout)-sum(~isnan(grunnvann)))


end