%--------------------------------------------------------------------------
% get a fresh start:
clear all; close all; clc

% Toggle Linux/Windows path
if ispc
    bp = 'N:\Inby\Aktive-prosjekter\o120107_EmSite\';
    addpath N:\Inby\Users\heg\MatLab\Tools
else
    bp =  '/storage/nilu/Inby/Aktive-prosjekter/o120107_EmSite/';
    addpath /storage/nilu/Inby/Users/heg/MatLab/Tools
end
%--------------------------------------------------------------------------
ipath    = sprintf('%s%s',bp,'EmSite_Model/Input/');

% make initial nc file based on the meteorolgical grid.
ncfile   = sprintf('%s%s',ipath,'BaseGrid.nc');
ifo      = ncinfo(ncfile);
x        = ncread(ncfile,'X');
y        = ncread(ncfile,'Y');
filename = sprintf('%s%s',ipath,'KMN/Kommuner2020'); 
KMN      = shaperead(filename);
fprintf('Adding Kommunenummer to grid centerpoint\n')
Komm     = zeros(length(x),length(y));
for i = 1:length(x)
    for j = 1:length(y)
        clear p
        for k=1:length(KMN)
            in = inpolygon(x(i),y(j),KMN(k).X,KMN(k).Y);
            if in; p =k;  end
        end
        if exist('p')
            Komm(i,j) =  KMN(p).KOMMUNENUM;
        else
            Komm(i,j) =  -1;
        end        
    end
    fprintf('%i / %i\n',i, length(x))
end
Vname     = sprintf('KMN');
LVname    = sprintf('Kommune');
nccreate(ncfile, Vname, 'Dimensions', {'X', ifo.Dimensions(1).Length,'Y', ifo.Dimensions(2).Length}, 'DataType', 'single');
ncwrite( ncfile, Vname, Komm);

% 
% ofname=sprintf('%s_%s_w_ENVCON.nc',char(ScenStr(scen)),char(spec(sp)));
% if exist(ofname)
%     delete(ofname)
% end
% nccreate(ofname,   'i', 'Dimensions',{ 'i', nX}, 'DataType', 'single');
% ncwrite(ofname,    'i', 1:nX );
% ncwriteatt(ofname, 'i', 'long_name', 'EMEP grid x coordinate' );
% ncwriteatt(ofname, 'i', 'long_name', 'projection_x_coordinate');
% 
% nccreate(ofname,   'j', 'Dimensions',{ 'j', nY}, 'DataType', 'single');
% ncwrite(ofname,    'j', 1:nY );
% ncwriteatt(ofname, 'j', 'long_name', 'EMEP grid y coordinate' );
% ncwriteatt(ofname, 'j', 'long_name', 'projection_y_coordinate');
% 
% nccreate(ofname,   'N', 'Dimensions',{ 'N', nN}, 'DataType', 'single');
% ncwrite(ofname,    'N', 1:5 );
% ncwriteatt(ofname, 'N', 'long_name', 'N');
% 
% nccreate(ofname,  'time', 'Dimensions',{ 'time', nT}, 'DataType', 'single');
% ncwrite(ofname,   'time', -1 );
% ncwriteatt(ofname,'time', 'long_name', 'time' );
% 
% nccreate(ofname,   'lat', 'Dimensions', {'i', nX,'j', nY}, 'DataType', 'double');
% ncwrite(ofname ,   'lat', y2 );
% ncwriteatt(ofname, 'lat', 'long_name','latitude');
% ncwriteatt(ofname, 'lat', 'units','degrees_north');
% 
% nccreate(ofname,   'lon', 'Dimensions', {'i', nX,'j', nY}, 'DataType', 'double');
% ncwrite(ofname ,   'lon', x2 );
% ncwriteatt(ofname, 'lon', 'long_name','longitude');
% ncwriteatt(ofname, 'lon', 'units','degrees_east');

% nccreate( ncfile  , Vname, 'Dimensions', {'lon', ifo2.Dimensions(1).Length,'bnds',ifo2.Dimensions(2).Length,'lat', ifo2.Dimensions(3).Length}, 'DataType', 'single');
% ncwriteatt(ncfile, Vname, 'long_name',LVname);
% ncwriteatt(ncfile, Vname, 'units','tonnes/year');
% ncwriteatt(ncfile, Vname, 'FillValue','NaN');
% ncwriteatt(ncfile, Vname, 'numberofrecords',1);





