stop
global printsplit Emission_year opname

fprintf(printsplit)
fprintf('M E R G I N G   E M I S S I O N   S H A P E F I L E S \n')
fprintf(printsplit)
base = [{'Geometry'},{'BoundingBox'},{'X'},{'Y'},{'SSBID'},{'KommuneNR'}];

consfile = sprintf('%s%i_%s_SSB%i_IPM2',opname,Emission_year,'CONS',outgridsize);
demofile = sprintf('%s%i_%s_SSB%i_IPM2',opname,Emission_year,'DEMO',outgridsize);

CONSe = shaperead(consfile);
DEMOe = shaperead(demofile);

cf = fields(CONSe);
df = fields(DEMOe);
uf = unique([rf;cf]);

% Create fields missing in order to be able to concatonate the files.
tCONS = struct2table(CONSe);
tDEMO = struct2table(DEMOe);
for i=1:length(uf)
    
    cr = find(ismember(cf,uf(i)));
    if isempty(cr)
        fprintf('Will add field %s to CONS\n',char(uf(i)))
        tCONS.NeWfield(:) = 0;
        fix = find(ismember(tCONS.Properties.VariableNames,'NeWfield'));
        tCONS.Properties.VariableNames(fix) = uf(i);
    end
    
    dr = find(ismember(df,uf(i)));
    if isempty(dr)
        fprintf('Will add field %s to DEMO\n',char(uf(i)))
        tDEMO.NeWfield(:) = 0;
        fix = find(ismember(tCab.Properties.VariableNames,'NeWfield'));
        tDEMO.Properties.VariableNames(fix) = uf(i);
    end
end





% Base are variables to be kept constant.
Ibr = zeros(size(tRes.Properties.VariableNames));
for i=1:length(base)
    If = ismember(tRes.Properties.VariableNames,base(i));
    Ibr = Ibr|If;
end

Ibc = zeros(size(tCab.Properties.VariableNames));
for i=1:length(base)
    If = ismember(tCab.Properties.VariableNames,base(i));
    Ibc = Ibc|If;
end


% Special fields are variables to be added.
Isr = contains(tRes.Properties.VariableNames,{'EmH'});
Isc = contains(tCab.Properties.VariableNames,{'EmH'});

% Remaining are Additave fields that will to be added.
Iar = ~Ibr&~Isr;
Iac = ~Ibc&~Isc;









% Make SSBID numeric
if ismember(class(tRes.SSBID),{'cell'})
    v = str2num(char(tRes.SSBID));
    tRes.SSBID = v;
end

if ismember(class(tCab.SSBID),{'cell'})
    v = str2num(char(tCab.SSBID));
    tCab.SSBID = v;
end

% Deal with some old fields
if isfield(ResEm,'KOMMUNENR')
    if ismember(class(tRes.KOMMUNENR),{'cell'})
        v = str2num(char(tRes.KOMMUNENR));
        tRes.KOMMUNENR = v;
    end
    if ismember(class(tCab.KOMMUNENR),{'cell'})
        v = str2num(char(tCab.KOMMUNENR));
        tCab.KOMMUNENR = v;
    end
end

if isfield(ResEm,'FYLKE')
    if ismember(class(tRes.FYLKE),{'cell'})
        v = str2num(char(tRes.FYLKE));
        tRes.FYLKE = v;
    end
    if ismember(class(tCab.FYLKE),{'cell'})
        v = str2num(char(tCab.FYLKE));
        tCab.FYLKE = v;
    end
end

if isfield(CabEm,'bui2hut')
    tCab.bui2hut(isnan(tCab.bui2hut))=0;
    fprintf('..replaced NaN with zeros for Huts\n')
end




% New Method to speed up the merge. Parses the data   
fuID = unique([tRes.SSBID; tCab.SSBID]);
fprintf('Found %i unique fields\n',length(fuID))
% make a parsing function to deal with smaller tables.

fprintf('Go get a cup of coffee, this will take some time\n...\n')
% 1 find ids that only have one type of emissions.
% 2 extract these fields and group by themselves.
% 3 merge the remainig

[nuID,ai,bi] = intersect(tRes.SSBID, tCab.SSBID);
fprintf('found %i fields with residential Emissions\n',height(tRes))
fprintf('found %i fields with cabin Emissions\n',height(tCab))
fprintf('found %i fields with both residential and cabin\n',length(nuID))
tRes.NeedMerge(:)=0;tRes.NeedMerge(ai)=1;
tCab.NeedMerge(:)=0;tCab.NeedMerge(bi)=1;
ttRes = tRes(tRes.NeedMerge==0,:);
ttCab = tCab(tCab.NeedMerge==0,:);
ttTot = [ttRes;ttCab];
ttTot = removevars(ttTot,{'NeedMerge'});

% Add a variable that tells me how much is consumed 
% by cabins / residences in shared grids.
RestoCabFrac(1:height(ttRes))               = 1;
RestoCabFrac(1+height(ttRes):height(ttTot)) = 0;



fprintf('Combined %i fields with independent Emissions\n',height(ttTot))
tRes = tRes(tRes.NeedMerge==1,:);
tCab = tCab(tCab.NeedMerge==1,:);

fuID = unique([tRes.SSBID; tCab.SSBID]);
fprintf('Combining %i fields with co-Emissions\n',length(fuID))

% Parssect how many sections to split the data into. In reality did very
% little to speed up the process.
Parssect = 5;
pars = ceil(length(fuID)/Parssect);

% Make a very (unccesarily???) heavy merge of two tables. Dealing with
% variable sizes and properties on the parameters.
tOut  = table; tNow  = table;
ttemp = table; t2emp = table;
ts = now;
ruID= [];
k = 1; 
for p = 1 : Parssect
    fprintf('Parse %i / %i @',p,Parssect)
    % split the unique ids into sections.
    if p == 1
        uID = fuID(1:pars);
    elseif p == Parssect
        uID = fuID(pars*(p-1)+1:end);
    else
        uID = fuID(pars*(p-1)+1:pars*(p));
    end
    
    for i = 1:length(uID)
        idr = find(tRes.SSBID==uID(i));
        idc = find(tCab.SSBID==uID(i));
        if ~isempty(idr) && ~isempty(idc)

            % merge the two tables to align columns
            tNow = [tRes(idr,:);tCab(idc,:)];
            
            % add the additive columns
            ttemp = array2table(nansum(table2array(tNow(:,Iar)),1));
            ttemp.Properties.VariableNames = tNow.Properties.VariableNames(Iar);
            % Treat the special column
            t2emp = array2table((table2array(tNow(1,Isr))*tNow.GridConsumption(1)+table2array(tNow(2,Isr))*tNow.GridConsumption(2))/nansum(tNow.GridConsumption));
            t2emp.Properties.VariableNames = tNow.Properties.VariableNames(Isr);
            temp  = [tNow(1,Ibr),ttemp,t2emp];
            
            tOut =[tOut;temp];
            frac(k) = tRes.GridConsumption(idr)/(tRes.GridConsumption(idr)+tCab.GridConsumption(idc));
            k = k+1;
        else
            tOut =[tOut;tRes(idr,:);tCab(idc,:)];
        end
        if rem(i,1000)==0; fprintf('%3i%%,',floor(100*i/length(uID))); end
    end
    fprintf('100%%\n')
    ts2 = now;
    fprintf('%3.1f min %i of %i \n',(ts2-ts)*(24*60),height(tOut),length(fuID))
end

tOut = [tOut;ttTot];
tOut.RestoCabFrac =[frac,RestoCabFrac]';


% Structurize the output table
S    = table2struct(tOut);

% Remove some fields not relevant for the output
if isfield(S,{'KOMMUNENR'})
    S = rmfield(S,{'KOMMUNENR'});
end

if isfield(S,{'FYLKENR'})
    S = rmfield(S,{'FYLKENR'});
end

if isfield(S,{'FYLKE'})
    S = rmfield(S,{'FYLKE'});
end

if isfield(S,{'WOODPOTENTIAL'})
    S = rmfield(S,{'WOODPOTENTIAL'});
end

if isfield(S,{'SmallHouseFraction'})
    S = rmfield(S,{'SmallHouseFraction'});
end

if isfield(S,{'dwe_area'})
    S = rmfield(S,{'dwe_area'});
end

if isfield(S,{'dwe_oth'})
    S = rmfield(S,{'dwe_oth'});
end

if isfield(S,{'dwe_com'})
    S = rmfield(S,{'dwe_com'});
end

end
