function [Met] = Emsite_Calc_findDaylight(Emission_year,ipath)

stop
% Toggle Linux/Windows path
if ispc
    bp = 'N:\Inby\Aktive-prosjekter\o120107_EmSite\';
    addpath N:\Inby\Users\heg\MatLab\Tools
else
    bp =  '/storage/nilu/Inby/Aktive-prosjekter/o120107_EmSite/';
    addpath /storage/nilu/Inby/Users/heg/MatLab/Tools
end
%--------------------------------------------------------------------------
% BASIC pathnames
opname   = sprintf('%s%s',bp,'EmSite_Model/Output/');
ipath    = sprintf('%s%s',bp,'EmSite_Model/Input/');

Emission_year = 2017;
if ispc
    ifil = 'N:\Inby\Emission_Group/Emission_Models/MetVed/MetVed_v2/Input/Shapefiles/Geographical/Elevation/Norway_Elevation_Grid_33N';
else
    ifil =  '/storage/nilu/Inby/Emission_Group/Emission_Models/MetVed/MetVed_v2/Input/Shapefiles/Geographical/Elevation/Norway_Elevation_Grid_33N';
end
s = shaperead(ifil);

for i =1:length(s)
    zx(i) = nanmean(extractfield(s(i),'X'));
    zy(i) = nanmean(extractfield(s(i),'Y'));
    z(i)  = max(0,extractfield(s(i),'z'));
end

ncfile2    = sprintf('%sMET/rr_%04i.nc',ipath,Emission_year);
lat        = ncread(ncfile2,'lat');
lon        = ncread(ncfile2,'lon');
y          = ncread(ncfile2,'Y');
x          = ncread(ncfile2,'X');

noti = 1000;k = 1;
for i=1:size(x,1)
    for j=1:size(y,1)
        
        dst = sqrt((zx - x(i)).^2 + (zy -y(j)).^2);
        if min(dst) < 12*1e3
            zMet(i,j) = z(find(dst == min(dst)));
        else
            zMet(i,j) = -1;
        end
        if zMet(i,j)>=0
            for m=1:12
                dt = datenum([Emission_year,m,16,0, 0, 0]);
                % LAt  Lon Alt TZ date
                su(i,j,m) = sunrise(lat(i,j),lon(i,j),zMet(i,j),2,datestr(dt,'yyyy-mm-dd'));
            end
        end
        if rem(k,noti)==0; fprintf('.'); if rem(k,10*noti)==0; fprintf('%i / %i %4.2f \n',k,size(x,1)*size(y,1),k/(size(x,1)*size(y,1))); end; end
        k = k+1;
        
    end
end
save('DaylightHrsMetGrid.mat','zMet','su')

ofname = sprintf('%sDaytime.nc',ipath);
ifo = ncinfo(ofname);
mnd = [{'Jan'},{'Feb'},{'Mar'},{'Apr'},{'May'},{'Jun'},{'Jul'},{'Aug'},{'Sep'},{'Oct'},{'Nov'},{'Dec'}];
for i=1:size(ifo.Variables,2)
    a(i) = {ifo.Variables(i).Name};
end
for m = 1:12
    Ovar = su(:,:,m);
    Vname     = char(mnd(m));
    LVname    = Vname;
    
    if sum(ismember(a,Vname))==0
    nccreate(ofname  , Vname, 'Dimensions', {'X', ifo.Dimensions(1).Length,'Y', ifo.Dimensions(2).Length}, 'DataType', 'single');
    end
    ncwrite(ofname   , Vname, Ovar);    
end


makeplot = 1
if makeplot
    fname = 'Daytime_Hrs';
    f = figure(1); clf
    for i=1:12
        subplot(4,3,i)
        [~,h] = contourf(x,y,su(:,:,i)'*24,98);
        h.LineColor = 'none';
        ch = colorbar;
        ch.Limits = [0 24];
        ch.Ticks = [0:3: 24];
        colormap(parula(98))
        title(sprintf('Average #hours with sun above the horizon in %s',char(mnd(i))))
    end
    saveas(f,fname,'png')
    fprintf('saved: %s\n',fname)
    
    fname = 'Altitude_MetGrid';
    f = figure(2); clf
    imagesc(zMet')
    colorbar
    title('Average Height of each MetGrid')
end
saveas(f,fname,'png')
fprintf('saved: %s\n',fname)
end


% clc
% clear all
% close all
% 
% Emission_year = 2019;
% 
% %n    = input('enter the No. of day  ');
% phi   = 1;%input('enter latitude  ');
% K     = .2; %input('enter averaged monthly clearness index  ');
% Beta  = 60; %input('enter surface angle  ');
% %Lst  = 52.5;%input('enter country longtitude  ');
% %Lloc = 51.5;%input('enter city longtitude    ');
% %t    = [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 ];%t=input('enter the time in hour  ');  solar time
% %B    = (pi./180).*(n-1).*(360/365);
% %E    = 229.2.*(.000075+.001868.*cos(B)-.032077.*sin(B)-.014615.*cos(2.*B)-.04089.*sin(2.*B));
% %solar_time = 4.*(L_st-L_loc)+E+standard_time;
% Gsc=1353;
% rou=0.2;
% for t=1:24
%     for n=1:1:365
%         sigma(t,n) = 23.45.*sind(360*(284+n)/365);
%         w(t,n)     = 15.*(t-12);
%         Goh(t,n)   = Gsc.*(1+0.033.*cosd(360.*(n)./365)).*(cosd(phi).*cosd(sigma(t,n)).*cosd(w(t,n))+sind(phi).*sind(sigma(t,n)));
%         Ws(t,n)    = acosd(-tand(phi).*tand(sigma(t,n)));
%         a(t,n)     = .409+.5016*sind(((Ws(t,n))-60));
%         b(t,n)     = .6607-.4767.*sind(((Ws(t,n))-60));
%         kt(t,n)    = (a(t,n)+b(t,n).*cosd(w(t,n))).*K;
%         Gh(t,n)    = kt(t,n).*Goh(t,n);
%     end
% end
% 
% for t=1:24
%     for n=1:365
%         if kt(t,n) <0.35
%             Gd(t,n)=Gh(t,n).*(1-.249.*kt(t,n));
%         elseif ((kt(t,n)>0.35)&&(kt(t,n)<0.75))
%             Gd(t,n)=Gh(t,n).*(1.557-1.84.*kt(t,n));
%         elseif kt(t,n)>0.75 
%             Gd(t,n)=Gh(t,n).*.177;
%         end
%     end
% end
% 
% Rb=((sind(sigma).*sind((phi-Beta)))+cosd(sigma).*cosd((phi-Beta))...
%     .*cosd(w))./((sind(sigma).*sind((phi))+cosd(sigma).*cosd((phi))...
%     .*cosd((w))));
% Gb=Gh-Gd;
% Gt=Gb.*Rb+Gd.*(1+cosd(Beta))./2+((1-cosd(Beta))/2).*(Gb+Gd).*rou;
% 
% 
% 
% Gb(:,1)
% 
% 
% plot(Gb)
% 
% 
% 
% 
% 
% 
% imagesc(zMet')
% 
% rlat = round(lat*10)/10;
% f9 = unique(rlat);
% noti = 5000;
% for l = 1:length(f9)    
%     for m=1:12
%         % LAt  Lon Alt TZ date
%         su(l,i) = sunrise(f9(l),15.03,1000,2,datestr(dt(m),'yyyy-mm-dd'));
%          
%         if rem(b,noti)==0; fprintf('.'); if rem(b,10*noti)==0; fprintf('\n'); end; end
%     end
% end
% 
% % Monthly mean daylight hours
% dv = datevec(dt);
% 
% 
% for i = 1:12
%     
%     
%     
% end
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
