%--------------------------------------------------------------------------
% get a fresh start:
clear all; close all; clc

% Toggle Linux/Windows path
if ispc
    bp = 'N:\Inby\Aktive-prosjekter\o120107_EmSite\';
    addpath N:\Inby\Users\heg\MatLab\Tools
else
    bp =  '/storage/nilu/Inby/Aktive-prosjekter/o120107_EmSite/';
    addpath /storage/nilu/Inby/Users/heg/MatLab/Tools
end
%--------------------------------------------------------------------------


% read in the FKB files and make one large file of them
FKBfile = sprintf('%sEmSite_Model/Output/%s',bp,'FKB_tiltak_All_Roads');

S0 = shaperead(sprintf('%sData/GeoNorge_data/%s',bp,'FKB_tiltak_roadP_0920'));
for i = 1:length(S0)
    xt = extractfield(S0(i),'X');
    x0(i) = xt(1);
end
S1 = shaperead(sprintf('%sData/GeoNorge_data/%s',bp,'FKB_tiltak_roadP_1120'));
for i = 1:length(S1)
    xt = extractfield(S1(i),'X');
    x1(i) = xt(1);
end
S2 = shaperead(sprintf('%sData/GeoNorge_data/%s',bp,'FKB_tiltak_roadP_1220'));
for i = 1:length(S2)
    xt = extractfield(S2(i),'X');
    x2(i) = xt(1);
end
S = [S0;S1;S2];

% Use the first location to eliminate double entries
Snew =[];
for i = 1:length(S)
    xt = extractfield(S(i),'X');
    xf(i) = xt(1);
end
Xpos = unique(xf);
for i=1:length(Xpos)
    idx = find(xf == Xpos(i));
    Snew = [Snew,S(idx(1))];
end




dbf = makedbfspec(Snew);
shapewrite(Snew,FKBfile,'DbfSpec', dbf)












file(1) = {sprintf('%s%s',bp,'Data/NVDB_Veganlegg_data/Download 15Jun2021/Veganlegg_utvida')};
file(2) = {sprintf('%s%s',bp,'Data/NVDB_Veganlegg_data/Download 12Arp2021/Veganlegg')};
file(3) = {sprintf('%s%s',bp,'Data/NVDB_Veganlegg_data/Download 11Nov2020/Veganlegg')};

file(4) = {sprintf('%s%s',bp,'Data/NVDB_Veganlegg_data/Download 15Jun2021/Veganlegg_utvida_flategeometri')};
file(5) = {sprintf('%s%s',bp,'Data/NVDB_Veganlegg_data/Download 12Arp2021/Veganlegg_flategeometri')};
file(6) = {sprintf('%s%s',bp,'Data/NVDB_Veganlegg_data/Download 11Nov2020/Veganlegg_flategeometri')};


% Loop through all source files to find all the unique fields:
f ={};
for i=1:6
    S = shaperead(char(file(i)));
    f1 = fieldnames(S); 
    f = unique([f;f1]);
    unique(extractfield(S,'Link_til_p'))'


end

S2 = [];
for i=1:3
    S = shaperead(char(file(i)));
    if i==1
        S2=S;
    else
    S2 = catstruct(S2,S);
    end
end
T = table(f');
T.Properties.VariableNames = f








lid = extractfield(S,'lokalid');



for i = 1:length(lid)


end






unique(extractfield(S,'tiltaksbes'))'
unique(extractfield(S,'objtype'))'
unique(extractfield(S,'lokalid'))'

unique(extractfield(S,'saksnummer'))'


% https://viken.no/tjenester/vei-og-kollektiv/fylkesvei/
% https://www.vestlandfylke.no/fylkesveg/vegprosjekt-i-vestland
% https://www.trondelagfylke.no/vare-tjenester/prosjekter/prosjekter-i-trondelag/    
% https://www.vegvesen.no/vegprosjekter/
% https://mrfylke.no/veg-og-kollektiv/vegprosjekt/fv.-63-korsmyra-indreeide
% https://agderfk.no/vare-tjenester/samferdsel/fylkesveg/vegprosjekter/


%     if ~isempty(S2)
%         S2 = [S2,S];
%         f2 = fieldnames(S2);
%         [ai bi ci] = intersect(f1,f2)
%         S2 = [S2,S];
%     end

























